# AISettingsWindow Struct Reference

Window for settings the parameters of an AI. More...

Inheritance diagram for AISettingsWindow:

## Public Member Functions
| AISettingsWindow (const WindowDesc *desc, CompanyID slot)
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
void | CheckDifficultyLevel ()
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnQueryTextFinished (char *str)
| The query window opened from this window has closed.
virtual void | OnResize ()
| Called after the window got resized.
virtual void | OnTick ()
| Called once per (game) tick.
## Data Fields
CompanyID | slot
AIConfig * | ai_config
int | clicked_button
bool | clicked_increase
int | timeout
int | clicked_row
int | line_height

## Detailed Description

Window for settings the parameters of an AI.

Definition at line 233 of file ai_gui.cpp.

## Member Function Documentation

virtual void AISettingsWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 272 of file ai_gui.cpp.

References _dynlang, AICONFIG_BOOLEAN, AICONFIG_INGAME, AIS_WIDGET_BACKGROUND, DrawArrowButtons(), DrawFrameRect(), DrawString(), FR_LOWERED, AIConfig::GetConfigList(), AIConfig::GetSetting(), Scrollbar::IsVisible(), max(), min(), SetDParam(), TD_RTL, DynamicLanguages::text_dir, Window::vscroll, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and WD_MATRIX_TOP.

virtual void AISettingsWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 324 of file ai_gui.cpp.

References _dynlang, AICONFIG_BOOLEAN, AICONFIG_INGAME, AIS_WIDGET_ACCEPT, AIS_WIDGET_BACKGROUND, AIS_WIDGET_RESET, CS_NUMERAL, NWidgetBase::current_x, AIConfigItem::flags, AIConfig::GetConfigList(), Scrollbar::GetPosition(), AIConfig::GetSetting(), IsInsideMM(), AIConfigItem::max_value, AIConfigItem::min_value, AIConfigItem::name, NWidgetBase::pos_x, NWidgetBase::pos_y, AIConfig::ResetSettings(), Window::SetDirty(), SetDParam(), AIConfig::SetSetting(), ShowQueryString(), AIConfigItem::step_size, TD_RTL, DynamicLanguages::text_dir, and Window::vscroll.

virtual void AISettingsWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 267 of file ai_gui.cpp.

References Window::DrawWidgets().

virtual void AISettingsWindow::OnQueryTextFinished | ( | char * | str | ) | `[inline, virtual]`

The query window opened from this window has closed.

Parameters:

  | str | the new value of the string, NULL if the window was cancelled or an empty string when the default button was pressed, i.e. StrEmpty(str).

Reimplemented from Window.

Definition at line 386 of file ai_gui.cpp.

References AIConfig::GetConfigList(), Window::SetDirty(), AIConfig::SetSetting(), and StrEmpty().

virtual void AISettingsWindow::OnResize | ( |  | ) | `[inline, virtual]`

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 397 of file ai_gui.cpp.

References AIS_WIDGET_BACKGROUND, NWidgetBase::current_y, Scrollbar::GetCapacity(), MAT_COL_START, MAT_ROW_START, Scrollbar::SetCapacity(), Window::vscroll, and NWidgetCore::widget_data.

virtual void AISettingsWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 256 of file ai_gui.cpp.

References AIS_WIDGET_BACKGROUND, FONT_HEIGHT_NORMAL, GB(), MAT_ROW_BITS, MAT_ROW_START, WD_MATRIX_BOTTOM, and WD_MATRIX_TOP.

The documentation for this struct was generated from the following file:

- src/ai/ai_gui.cpp